$regfile = "m16def.dat"
$crystal = 1000000
$baud = 1200
$hwstack = 32
$swstack = 10
$framesize = 40

Declare Function Karte_gesteckt() As Byte
Declare Sub Wait_for_ready()
Declare Sub Write_byte(byval Reg_adr As Byte , Byval Wbyte As Byte)
Declare Function Read_byte(byval Reg_adr As Byte) As Byte

'Daten:    PortA
'Adressen: PortC
'Reset:    PortB.2
'CE1:      PortB.0
'OE:       PortB.3
'CD1:      PortB.1
'WE:       PortB.4
'BSY:      PinD.6

Res Alias Portb.2
Ce1 Alias Portb.0
Oe Alias Portb.3
We Alias Portb.4
Cd1 Alias Pinb.1
Rdy Alias Pind.6

Dim Daten As Byte
Dim Buf(512) As Byte                                        'Datenpuffer fr 1 Sektor
Dim I As Word

Config Porta = Input                                        'Daten
Config Portc = Output                                       'Adressen
Config Portd = Input                                        'nur fr ready
Porta = 0 = 0                                               'def. Status
Portd = &HFF                                                'pullups an fr Rdy
Ddrb = &B00011101                                           'Steuerport
Portb.1 = 1                                                 'pullup aktivieren CD1

Reset Res
Set Ce1
Set Oe
Set We

'****************************************************************
Print "Start CF-Test"

'steckt eine Karte?
While Karte_gesteckt() = 0
      Print "Karte nicht gesteckt!"
      Wait 1
Wend
Print "Karte gesteckt"

'Reset und warten bis fertig
Set Res
Waitus 1
Reset Res
Wait_for_ready
Print "Bereit (Signalleitung)"

Ce1 = 0                                                     'CF-Karte aktivieren
Wait_for_ready

'test registers - schreiben und zurcklesen
Write_byte 2 , &H02
Write_byte 3 , &H03
Write_byte 4 , &H04
Write_byte 5 , &H05
Write_byte 6 , &HF6

      Daten = Read_byte(2)
Print "test2" ; " " ; Hex(daten)
      Daten = Read_byte(3)
Print "test3" ; " " ; Hex(daten)
      Daten = Read_byte(4)
Print "test4" ; " " ; Hex(daten)
      Daten = Read_byte(5)
Print "test5" ; " " ; Hex(daten)
      Daten = Read_byte(6)
Print "test6" ; " " ; Hex(daten)


Ce1 = 1                                                     'Karte deaktivieren
Do : Loop


Function Karte_gesteckt() As Byte
' prfen, ob Karte gesteckt ist, 1= erfolg
      If Cd1 = 1 Then Karte_gesteckt = 0 Else Karte_gesteckt = 1
End Function

Sub Wait_for_ready()
      While Rdy = 0
      Wend
End Sub

Sub Write_byte(byval Reg_adr As Byte , Byval Wbyte As Byte)
      Wait_for_ready
      Config Porta = Output
      Porta = Wbyte
      Portc = Reg_adr
      Waitus 1
      We = 0
      Waitus 1
      We = 1
      Waitus 1
End Sub

Function Read_byte(byval Reg_adr As Byte) As Byte
      Wait_for_ready
      Config Porta = Input
      Portc = Reg_adr
      Waitms 1
      Oe = 0
      Waitms 1
      Read_byte = Pina
      Oe = 1
      Waitms 1
End Function

End